﻿/*
* kner 2015
* key debounce version 1 (does not work) 
* problem: bounce as well on pressing as on releasing the button => slowly pressing the key may result in 2 interrupts: one
* when pressing and one when releasing
* 
* Bad: block the interrupt for 30ms
*
* connect a button on Arduino Pin 2 to GND
*/

#include <Arduino.h>

#define DEBUG_LCD
#include "_debug.h"

int g; 
ISR(INT0_vect){
   L(g);g++;            //count the number of interrupts
   //wait a little
   WAIT_MS(30); 
   //clear pending Interrupts
   if (EIFR & _BV(INTF0))  EIFR = _BV(INTF0);
}
void setup()
{   //kill Arduino Timer0 Interrupt;  millis() not available!
	TIMSK0 &=~_BV(TOIE0);
	
	EICRA |= _BV(ISC01); //Falling edge
	EIMSK |= _BV(INT0); //enable external Interrupt 0
	
	pinMode(2,INPUT_PULLUP); //ext. Interrupt
}

void loop()
{
  volatile static int dummy=0; dummy++;  //needed for simulator if no additional lines of code   
}



